// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Create or update Availability Set parameters.
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class AvailabilitySetInner : Microsoft.Azure.Management.Resource.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the AvailabilitySetInner class.
        /// </summary>
        public AvailabilitySetInner() { }

        /// <summary>
        /// Initializes a new instance of the AvailabilitySetInner class.
        /// </summary>
        /// <param name="platformUpdateDomainCount">Update Domain
        /// count.</param>
        /// <param name="platformFaultDomainCount">Fault Domain count.</param>
        /// <param name="virtualMachines">a list containing reference to all
        /// Virtual Machines created under this Availability Set.</param>
        /// <param name="statuses">the resource status information.</param>
        public AvailabilitySetInner(string location = default(string), string id = default(string), string name = default(string), string type = default(string), System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), int? platformUpdateDomainCount = default(int?), int? platformFaultDomainCount = default(int?), System.Collections.Generic.IList<Microsoft.Azure.Management.Resource.Fluent.SubResource> virtualMachines = default(System.Collections.Generic.IList<Microsoft.Azure.Management.Resource.Fluent.SubResource>), System.Collections.Generic.IList<InstanceViewStatus> statuses = default(System.Collections.Generic.IList<InstanceViewStatus>))
            : base(location, id, name, type, tags)
        {
            PlatformUpdateDomainCount = platformUpdateDomainCount;
            PlatformFaultDomainCount = platformFaultDomainCount;
            VirtualMachines = virtualMachines;
            Statuses = statuses;
        }

        /// <summary>
        /// Gets or sets update Domain count.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.platformUpdateDomainCount")]
        public int? PlatformUpdateDomainCount { get; set; }

        /// <summary>
        /// Gets or sets fault Domain count.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.platformFaultDomainCount")]
        public int? PlatformFaultDomainCount { get; set; }

        /// <summary>
        /// Gets or sets a list containing reference to all Virtual Machines
        /// created under this Availability Set.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.virtualMachines")]
        public System.Collections.Generic.IList<Microsoft.Azure.Management.Resource.Fluent.SubResource> VirtualMachines { get; set; }

        /// <summary>
        /// Gets or sets the resource status information.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.statuses")]
        public System.Collections.Generic.IList<InstanceViewStatus> Statuses { get; set; }

    }
}
