// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Describes a reference to Key Vault Key
    /// </summary>
    public partial class KeyVaultKeyReference
    {
        /// <summary>
        /// Initializes a new instance of the KeyVaultKeyReference class.
        /// </summary>
        public KeyVaultKeyReference() { }

        /// <summary>
        /// Initializes a new instance of the KeyVaultKeyReference class.
        /// </summary>
        /// <param name="keyUrl">the URL referencing a key in a Key
        /// Vault.</param>
        /// <param name="sourceVault">the Relative URL of the Key Vault
        /// containing the key</param>
        public KeyVaultKeyReference(string keyUrl, Microsoft.Azure.Management.Resource.Fluent.SubResource sourceVault)
        {
            KeyUrl = keyUrl;
            SourceVault = sourceVault;
        }

        /// <summary>
        /// Gets or sets the URL referencing a key in a Key Vault.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "keyUrl")]
        public string KeyUrl { get; set; }

        /// <summary>
        /// Gets or sets the Relative URL of the Key Vault containing the key
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "sourceVault")]
        public Microsoft.Azure.Management.Resource.Fluent.SubResource SourceVault { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (KeyUrl == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "KeyUrl");
            }
            if (SourceVault == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "SourceVault");
            }
        }
    }
}
