// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// VirtualNetworkGatewaySku details
    /// </summary>
    public partial class VirtualNetworkGatewaySku
    {
        /// <summary>
        /// Initializes a new instance of the VirtualNetworkGatewaySku class.
        /// </summary>
        public VirtualNetworkGatewaySku() { }

        /// <summary>
        /// Initializes a new instance of the VirtualNetworkGatewaySku class.
        /// </summary>
        /// <param name="name">Gateway sku name
        /// -Basic/HighPerformance/Standard. Possible values include:
        /// 'Basic', 'HighPerformance', 'Standard'</param>
        /// <param name="tier">Gateway sku tier
        /// -Basic/HighPerformance/Standard. Possible values include:
        /// 'Basic', 'HighPerformance', 'Standard'</param>
        /// <param name="capacity">The capacity</param>
        public VirtualNetworkGatewaySku(string name = default(string), string tier = default(string), int? capacity = default(int?))
        {
            Name = name;
            Tier = tier;
            Capacity = capacity;
        }

        /// <summary>
        /// Gets or sets gateway sku name -Basic/HighPerformance/Standard.
        /// Possible values include: 'Basic', 'HighPerformance', 'Standard'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets gateway sku tier -Basic/HighPerformance/Standard.
        /// Possible values include: 'Basic', 'HighPerformance', 'Standard'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "tier")]
        public string Tier { get; set; }

        /// <summary>
        /// Gets or sets the capacity
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "capacity")]
        public int? Capacity { get; set; }

    }
}
